// memory-test.c
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#define MALLOC1_SIZE 1024*1024*16
#define MALLOC2_SIZE 1024

char global[1024*1024*32];     // 32 MB global

void subroutine (char *arg1, char *arg2) {
  char on_stack[1024*1024*2];  // 2 MB on stack

  printf ("global:    %010p (%5d K)\n", global, sizeof(global)/1024);
  printf ("on_stack:  %010p (%5d K)\n", on_stack, sizeof(on_stack)/1024);
  printf ("malloced1: %010p (%5d K)\n", arg1, MALLOC1_SIZE/1024);
  printf ("malloced2: %010p (%5d K)\n", arg2, MALLOC2_SIZE/1024);

  char cmd[30];
  sprintf ((char*)cmd, "pmap %d | grep -v /lib", getpid());
  system (cmd);
}

int main () {
  char *malloced1 = malloc (MALLOC1_SIZE);  // 16 MB malloc
  char *malloced2 = malloc (MALLOC2_SIZE);  //  1 KB malloc
  subroutine (malloced1, malloced2);
}
